<template>
  <div>
    <b-button variant="outline" v-b-modal="modalId">
      <div class="position-relative">
        <b-img-lazy :id="image.id" :src="image.link" class="image-viewer" :alt="title" fluid />
        <div class="position-absolute image-text">
          <span class="text-break">{{description}}</span>
        </div>
      </div>
      <span class="hidden-text">Press enter to view this image in fullsize and escape to exit fullscreen mode</span>
    </b-button>
    <b-modal :id="modalId" size="xl" body-bg-variant="light" centered hide-header hide-footer>
      <b-row class="text-black my-2">
        <b-col class="text-break">
          <div><span>Title: {{title}}</span></div>
          <div><span>Description: {{description}}</span></div>
          <div><span>Upvotes: {{upvotes}}</span></div>
          <div><span>Downvotes: {{downvotes}}</span></div>
          <div><span>Score: {{score}}</span></div>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <b-img-lazy :src="image.link" class="image-viewer-big rounded" :alt="title" fluid height="auto" />
        </b-col>
      </b-row>
    </b-modal>
  </div>
</template>

<script>
import {ImgurImage} from '../model/imgur-image'

export default {
  name: 'ImageViewer',
  props: {
    image: {
      type: ImgurImage,
      required: true
    }
  },
  computed: {
    modalId () {
      return `modal-${this.image.id}`
    },
    title () {
      return this.image.title ? this.image.title : 'there is no title available'
    },
    description () {
      return this.image.description ? this.image.description : 'there is no description available'
    },
    upvotes () {
      return this.image.ups ? this.image.ups : 0
    },
    downvotes () {
      return this.image.downs ? this.image.downs : 0
    },
    score () {
      return this.image.score ? this.image.score : 0
    }
  }
}
</script>

<style scoped>
.image-viewer {
  width: 100%;
  height: auto;
}
.image-viewer-big {
  width:100%;
}
.image-text {
  background-color: rgba(0, 0, 0, 0.8);
  padding: 5px 0;
  color: #fff;
  top: 0;
  left: 0;
  width: 100%;
  overflow: hidden;
  display: -webkit-box;
  -webkit-box-orient: vertical;
  -webkit-line-clamp: 3
}
.hidden-text {
  position: absolute;
  left: -99999px;
}
.btn.btn-outline {
  margin-top: 30px;
  margin-bottom: 30px;
}

.btn.btn-outline:focus {
  border: 2px solid #fff;
}
</style>
